//------------------------------------------------------//
//	[MathBench.cpp]										//
//	lZ̃x`}[N֐Q						//
//	2006.02.21 - 2006.02.21								//
//		Yutaka Yoshisaka								//
//------------------------------------------------------//

#include "MathBench.h"

#if WIN32
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>

#include "mmintrin.h"
#include "xmmintrin.h"

#else
#include <carbon/carbon.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//----------------------------------------------//
// ݂CPUȂǂ̏擾E\			//
//----------------------------------------------//
void mb_OutSystemInfo()
{
#if WIN32
	unsigned long vEAX, vEBX, vEDX, vECX;
	char szStr[256];
	char venderStr[64];
	int family, model, steppingID, procCou;
	
	vEAX = vEBX = vEDX = vECX = 0;

	// CPUID̃`FbN
	__try {
		_asm {
			pusha
			xor eax, eax
			cpuid
			mov vEBX, ebx
			mov vEDX, edx
			mov vECX, ecx
			popa
		}
	} __except(EXCEPTION_EXECUTE_HANDLER) {
		if(_exception_code() == STATUS_ILLEGAL_INSTRUCTION) return;
	}

	// CPUx_̎擾
	venderStr[0]  = (char)((vEBX & 0x000000ff) >>  0);
	venderStr[1]  = (char)((vEBX & 0x0000ff00) >>  8);
	venderStr[2]  = (char)((vEBX & 0x00ff0000) >> 16);
	venderStr[3]  = (char)((vEBX & 0xff000000) >> 24);
	venderStr[4]  = (char)((vEDX & 0x000000ff) >>  0);
	venderStr[5]  = (char)((vEDX & 0x0000ff00) >>  8);
	venderStr[6]  = (char)((vEDX & 0x00ff0000) >> 16);
	venderStr[7]  = (char)((vEDX & 0xff000000) >> 24);
	venderStr[8]  = (char)((vECX & 0x000000ff) >>  0);
	venderStr[9]  = (char)((vECX & 0x0000ff00) >>  8);
	venderStr[10] = (char)((vECX & 0x00ff0000) >> 16);
	venderStr[11] = (char)((vECX & 0xff000000) >> 24);
	venderStr[12] = '\0';

	// CPU擾
	__try {
		_asm {
			pusha
			mov eax, 1
			cpuid
			mov vEAX, eax
			mov vEBX, ebx
			mov vEDX, edx
			popa
		}
	} __except(EXCEPTION_EXECUTE_HANDLER) {
		if(_exception_code() == STATUS_ILLEGAL_INSTRUCTION) return;
	}
	family     = (vEAX & 0x00000f00) >> 8;
	model      = (vEAX & 0x000000f0) >> 4;
	steppingID = (vEAX & 0x0000000f);
	procCou    = (vEBX & 0x00ff0000) >> 16;

	sprintf(szStr, "CPU Vender   : %s\n", venderStr);
	printf(szStr);
	sprintf(szStr, "family       : %d\n", family);
	printf(szStr);
	sprintf(szStr, "model        : %d\n", model);
	printf(szStr);
	sprintf(szStr, "steppingID   : %d\n", steppingID);
	printf(szStr);
	sprintf(szStr, "vZbT : %d\n", procCou);
	printf(szStr);

	if(vEDX & 0x10000000) {
		printf("HiperThreadT|[gĂ܂B\n");
	} else {
		printf("HiperThreadT|[gĂ܂B\n");
	}
	if(vEDX & 0x04000000) {
		printf("SSE2T|[gĂ܂B\n");
	} else {
		printf("SSE2T|[gĂ܂B\n");
	}
	if(vEDX & 0x02000000) {
		printf("SSET|[gĂ܂B\n");
	} else {
		printf("SSET|[gĂ܂B\n");
	}
	if(vEDX & 0x00800000) {
		printf("MMXT|[gĂ܂B\n");
	} else {
		printf("MMXT|[gĂ܂B\n");
	}
#else
#endif

}


//----------------------------------------------//
// ݎmsPʂŎ擾						//
//----------------------------------------------//
long mb_GetNowTime()
{
	long tim;
#if WIN32
	tim = timeGetTime();
#else
	UnsignedWide ts;

	// ݂̌oߎԂ~bŋ߂
	Microseconds(&ts);		// }CNbPʂŎԂ擾
	tim = (long)(ts.lo / 1000);

#endif

	return tim;
}

//----------------------------------------------//
// ֐Ăяo							//
//----------------------------------------------//
void mb_BenchFuncCall()
{
	return;
}

//----------------------------------------------//
// Zs								//
//----------------------------------------------//
int mb_BenchAddInt(int a, int b)
{
	int c;
	c = a + b;
	return c;
}

//----------------------------------------------//
// Zs								//
//----------------------------------------------//
int mb_BenchSubInt(int a, int b)
{
	int c;
	c = a - b;
	return c;
}

//----------------------------------------------//
// Zs								//
//----------------------------------------------//
int mb_BenchMulInt(int a, int b)
{
	int c;
	c = a * b;
	return c;
}

//----------------------------------------------//
// Zs								//
//----------------------------------------------//
int mb_BenchDivInt(int a, int b)
{
	int c;
	c = a / b;
	return c;
}

//----------------------------------------------//
// _Zs							//
//----------------------------------------------//
float mb_BenchAddFloat(float a, float b)
{
	float c;
	c = a + b;
	return c;
}

//----------------------------------------------//
// _Zs							//
//----------------------------------------------//
float mb_BenchSubFloat(float a, float b)
{
	float c;
	c = a - b;
	return c;
}

//----------------------------------------------//
// _Zs							//
//----------------------------------------------//
float mb_BenchMulFloat(float a, float b)
{
	float c;
	c = a * b;
	return c;
}

//----------------------------------------------//
// _Zs							//
//----------------------------------------------//
float mb_BenchDivFloat(float a, float b)
{
	float c;
	c = a / b;
	return c;
}

//----------------------------------------------//
// fabss									//
//----------------------------------------------//
double mb_Bench_fabs(double val)
{
	return fabs(val);
}

//----------------------------------------------//
// fmods									//
//----------------------------------------------//
double mb_Bench_fmod(double val, double val2)
{
	return fmod(val, val2);
}

//----------------------------------------------//
// sqrts									//
//----------------------------------------------//
double mb_Bench_sqrt(double val)
{
	return sqrt(val);
}

//----------------------------------------------//
// rsqrtsit߂j			//
//----------------------------------------------//
double mb_Bench_rsqrt(double val)
{
	return (1.0 / sqrt(val));
}

//----------------------------------------------//
// coss									//
//----------------------------------------------//
double mb_Bench_cos(double val)
{
	return cos(val);
}

//----------------------------------------------//
// sins									//
//----------------------------------------------//
double mb_Bench_sin(double val)
{
	return sin(val);
}

//----------------------------------------------//
// pows									//
//----------------------------------------------//
double mb_Bench_pow(double val, double val2)
{
	return pow(val, val2);
}

//----------------------------------------------//
// fast_fabss								//
//----------------------------------------------//
double mb_Bench_fast_fabs(double val)
{
	return (val < 0) ? -val : val;
}

//----------------------------------------------//
// fast_fmods								//
//----------------------------------------------//
double mb_Bench_fast_fmod(double val, double val2)
{
	return (val - val2 * ((int)(val / val2)));
}

//----------------------------------------------//
// fast_rsqrts								//
//----------------------------------------------//
double mb_Bench_fast_rsqrt(double val)
{
	// ͂킴ƃm[}̕vZĂ܂
	double r;
	r = 1.0 / sqrt(val);

	return r;
}

//----------------------------------------------//
// fast_sqrts								//
//----------------------------------------------//
double mb_Bench_fast_sqrt(double val)
{
	// ͂킴ƃm[}̕vZĂ܂
	double r;
	r = sqrt(val);

	return r;
}

// ******************************************** //
//	xNgZ								//
// ******************************************** //

//------------------------------------------//
// xNg̒߂					//
//------------------------------------------//
float mb_VectorLength(const MB_VECTOR3 vec)
{
	double dx, dy, dz, len;

	dx = (double)vec.x;
	dy = (double)vec.y;
	dz = (double)vec.z;

	len = sqrt(dx * dx  + dy * dy + dz * dz);

	return (float)len;
}

//------------------------------------------//
// xNg̒߂i|C^nj	//
//------------------------------------------//
float mb_VectorLength2(const MB_VECTOR3 *pVec)
{
	double dx, dy, dz, len;

	dx = (double)pVec->x;
	dy = (double)pVec->y;
	dz = (double)pVec->z;

	len = sqrt(dx * dx  + dy * dy + dz * dz);

	return (float)len;
}

//------------------------------------------//
// xNg̒߂i|C^n2j	//
//------------------------------------------//
float mb_VectorLength3(const MB_VECTOR3 &vec)
{
	double dx, dy, dz, len;

	dx = (double)vec.x;
	dy = (double)vec.y;
	dz = (double)vec.z;

	len = sqrt(dx * dx  + dy * dy + dz * dz);

	return (float)len;
}

//------------------------------------------//
// xNg̒߂					//
//	fast_rsqrtgp							//
//------------------------------------------//
float mb_VectorLength4(const MB_VECTOR3 &vec)
{
	double dx, dy, dz, len;

	dx = (double)vec.x;
	dy = (double)vec.y;
	dz = (double)vec.z;

	len = mb_Bench_fast_sqrt(dx * dx  + dy * dy + dz * dz);

	return (float)len;
}


//------------------------------------------//
// xNg𐳋K							//
//------------------------------------------//
void mb_VectorNormalize(const MB_VECTOR3 *pVec, MB_VECTOR3 *pRetVec)
{
	double dx, dy, dz, len;

	dx = (double)(pVec->x);
	dy = (double)(pVec->y);
	dz = (double)(pVec->z);

	len = sqrt(dx * dx  + dy * dy + dz * dz);
	len = 1.0 / len;

	pRetVec->x = (float)(dx * len);
	pRetVec->y = (float)(dy * len);
	pRetVec->z = (float)(dz * len);
}


//------------------------------------------//
// xNg𐳋K							//
//	tvZƎɍs				//
//------------------------------------------//
void mb_VectorNormalize2(const MB_VECTOR3 *pVec, MB_VECTOR3 *pRetVec)
{
	double dx, dy, dz, len;

	dx = (double)(pVec->x);
	dy = (double)(pVec->y);
	dz = (double)(pVec->z);

	len = mb_Bench_fast_rsqrt(dx * dx  + dy * dy + dz * dz);

	pRetVec->x = (float)(dx * len);
	pRetVec->y = (float)(dy * len);
	pRetVec->z = (float)(dz * len);
}

