//------------------------------------------------------//
//	[MathBench.h]										//
//	lZ̃x`}[N֐Q						//
//	2006.02.21 - 2006.02.21								//
//		Yutaka Yoshisaka								//
//------------------------------------------------------//

#ifndef _MATHBENCH_H
#define _MATHBENCH_H

//----------------------------------------------//
//	\										//
//----------------------------------------------//
// xNg
typedef struct {
	float x, y, z;
} MB_VECTOR3;

// ݂CPUȂǂ̏擾E\
void mb_OutSystemInfo();

// ݎmsPʂŎ擾
long mb_GetNowTime();

// ֐Ăяo
void mb_BenchFuncCall();

//----------------------------------------------//
//	{̎lZ								//
//----------------------------------------------//
// Zs
int mb_BenchAddInt(int a, int b);

// Zs
int mb_BenchSubInt(int a, int b);

// Zs
int mb_BenchMulInt(int a, int b);

// Zs
int mb_BenchDivInt(int a, int b);

// _Zs
float mb_BenchAddFloat(float a, float b);

// _Zs
float mb_BenchSubFloat(float a, float b);

// _Zs
float mb_BenchMulFloat(float a, float b);

// _Zs
float mb_BenchDivFloat(float a, float b);

//----------------------------------------------//
//	ZpZ									//
//----------------------------------------------//
// fabss
double mb_Bench_fabs(double val);

// fmods
double mb_Bench_fmod(double val, double val2);

// sqrts
double mb_Bench_sqrt(double val);

// rsqrtsit߂j
double mb_Bench_rsqrt(double val);

// coss
double mb_Bench_cos(double val);

// sins
double mb_Bench_sin(double val);

// pows
double mb_Bench_pow(double val, double val2);

//----------------------------------------------//
//	vZ									//
//----------------------------------------------//
// fast_fabss
double mb_Bench_fast_fabs(double val);

// fast_fmods
double mb_Bench_fast_fmod(double val, double val2);

// fast_rsqrts
double mb_Bench_fast_rsqrt(double val);

// fast_sqrts
double mb_Bench_fast_sqrt(double val);

//----------------------------------------------//
//	xNgZ								//
//----------------------------------------------//
// xNg̒߂
float mb_VectorLength(const MB_VECTOR3 vec);

// xNg̒߂i|C^nj
float mb_VectorLength2(const MB_VECTOR3 *pVec);

// xNg̒߂i|C^n2j
float mb_VectorLength3(const MB_VECTOR3 &vec);

// xNg̒߂ivZƎɍsj
float mb_VectorLength4(const MB_VECTOR3 &vec);

// xNg𐳋K
void mb_VectorNormalize(const MB_VECTOR3 *pVec, MB_VECTOR3 *pRetVec);

// xNg𐳋KitvZƎɍsj
void mb_VectorNormalize2(const MB_VECTOR3 *pVec, MB_VECTOR3 *pRetVec);

#endif
